var map;
var layers = [];

var currentViewState = {
    longitude: -122.45,
    latitude: 37.78,
    zoom: 12
};

const LIGHT_TILE = 'https://c.tile.openstreetmap.org/{z}/{x}/{y}.png';
const DARK_TILE = 'https://tiles.stadiamaps.com/tiles/alidade_smooth_dark/{z}/{x}/{y}.png';

const ARC_DATA = 'https://raw.githubusercontent.com/visgl/deck.gl-data/master/website/bart-segments.json';
const HEATMAP_DATA = 'https://raw.githubusercontent.com/visgl/deck.gl-data/master/website/sf-bike-parking.json';
const HEXAGON_DATA = 'https://raw.githubusercontent.com/visgl/deck.gl-data/master/website/sf-bike-parking.json';
const ELEVATION_DATA = 'https://raw.githubusercontent.com/visgl/deck.gl-data/master/website/terrain.png';
const ELEVATION_DECODER = {
    rScaler: 2,
    gScaler: 0,
    bScaler: 0,
    offset: 0
};
const TERRAIN_TEXTURE = 'https://raw.githubusercontent.com/visgl/deck.gl-data/master/website/terrain-mask.png';

// queste funzioni devono ritornare un layer gia inizializzato con: new deck.LAYER_SCELTO
function createOrthomapLayer(props) {
}

function createArcLayer(props) {
}

function createHeatmapLayer(props) {
}

function createHexagonLayer(props) {
}

function createTerrainLayer(props) {
}

function addEventListeners() {
    // Usare map.setProps({ ... }); con le proprieta della mappa che volete aggiornare.
    // In questo caso basta solo aggiornare la proprieta layers
    document.getElementById('arc_btn').addEventListener('click', () => {
    });
    document.getElementById('heat_btn').addEventListener('click', () => {
    });
    document.getElementById('hex_btn').addEventListener('click', () => {
    });
    document.getElementById('ter_btn').addEventListener('click', () => {
    });
}

function onLoad() {
    console.log('loading map');
    layers.push(createOrthomapLayer());
    map = new deck.Deck({
        viewState: currentViewState,
        canvas: document.getElementById('cvs'),
        onViewStateChange: ({ viewState }) => {
            currentViewState = viewState
            map.setProps({ viewState: { ...currentViewState } });
        },
        controller: true,

        layers: [
            ...layers,
        ],

        getTooltip: ({ layer, object }) => {
            if (layer) {
                switch (layer.id) {
                    case "ArcLayer":
                        return object &&
                            `${object.from.name} to ${object.to.name}`
                    case "HexagonLayer":
                        return object &&
                            `${object.position.join(', ')} 
                                Count: ${object.points.length}`
                }
            }
        }
    });
    addEventListeners();
}

window.onload = onLoad;